//======================================================================
//
//  Copyright (C) 1996, 1997 Mark Russinovich and Bryce Cogswell  !!!!!!
//                           ----------------     --------------
//  Typedefs and defines.
// 
//  MODIFIED : WANG Nianhua ,2006/10/10
//
//======================================================================

typedef unsigned int    UINT;
typedef char            CHAR;
typedef char *          PCHAR;
typedef PVOID           POBJECT;


#define INVALID_HANDLE_VALUE  ((HANDLE) -1)

#if defined(_ALPHA_)
#define SYSCALL(_function)  ServiceTable->ServiceTable[ (*(PULONG)_function)  & 0x0000FFFF ]
#else
#define SYSCALL(_function)  ServiceTable->ServiceTable[ *(PULONG)((PUCHAR)_function+1)]
#endif

#define IOCTL_TRANSFER_TYPE( _iocontrol)   (_iocontrol & 0x3)

typedef struct _SRVTABLE {
	PVOID           *ServiceTable;
	ULONG           LowCall;        
	ULONG           HiCall;
	PVOID		*ArgTable;
} SRVTABLE, *PSRVTABLE;

NTSYSAPI  NTSTATUS NTAPI ZwDeviceIoControlFile(
                      IN HANDLE FileHandle,
                      IN HANDLE Event OPTIONAL,
                      IN PIO_APC_ROUTINE ApcRoutine OPTIONAL,
                      IN PVOID ApcContext OPTIONAL,
                      OUT PIO_STATUS_BLOCK IoStatusBlock,
                      IN ULONG IoControlCode,
                      IN PVOID InputBuffer OPTIONAL,
                      IN ULONG InputBufferLength,
                      OUT PVOID OutputBuffer OPTIONAL,
                      IN ULONG OutputBufferLength
                      );

typedef NTSTATUS (*ZWDEVICEIOCONTROLFILE)(
                                          IN HANDLE FileHandle,
                                          IN HANDLE Event OPTIONAL,
                                          IN PIO_APC_ROUTINE ApcRoutine OPTIONAL,
                                          IN PVOID ApcContext OPTIONAL,
                                          OUT PIO_STATUS_BLOCK IoStatusBlock,
                                          IN ULONG IoControlCode,
                                          IN PVOID InputBuffer OPTIONAL,
                                          IN ULONG InputBufferLength,
                                          OUT PVOID OutputBuffer OPTIONAL,
                                          IN ULONG OutputBufferLength 
                                         );

extern PSRVTABLE KeServiceDescriptorTable;


