//======================================================================
//
// Copyright (C) 1996, 1997 Mark Russinovich and Bryce Cogswell
//
// Common header file for device driver and GUI. Contains common
// data structure definitions and IOCTL command codes.
//
// Modify: WANG Nianhua ,2006/10/10
//======================================================================
#ifndef _COMMDEF_H_
#define _COMMDEF_H_
//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//

#define FILE_DEVICE_REGMON      0x00008305


#define DRIVER_NAME             L"HDHOOK"
#define SERVICE_NAME            "HDHOOK"
#define DRIVER_FILE_NAME        "HdHook.sys"
#define PROFILE_APP_NAME        "HDHOOK"
#define PROFILE_KEY_NAME_CUR    "Current"
#define PROFILE_KEY_NAME_NEW    "New"


//
// Version #
//
#define REGMONVERSION    360


//
// Commands that the GUI can send the device driver
//
#define HDHOOK_HOOK                  (ULONG) CTL_CODE( FILE_DEVICE_REGMON, 0x00, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define HDHOOK_UNHOOK                (ULONG) CTL_CODE( FILE_DEVICE_REGMON, 0x01, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define HDHOOK_VERSION               (ULONG) CTL_CODE( FILE_DEVICE_REGMON, 0x02, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define HDHOOK_SETSELFVALUE          (ULONG) CTL_CODE( FILE_DEVICE_REGMON, 0x03, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define HDHOOK_SETEMULABLEVALUE      (ULONG) CTL_CODE( FILE_DEVICE_REGMON, 0x04, METHOD_BUFFERED, FILE_ANY_ACCESS )


#define DISK_SERIAL_BUFF_LENGTH      20


#endif